﻿using Barsalt.ParameterSystem;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Assets.ParameterSystem {
	/// <summary>
	/// The ParameterEvent contains information about which entries of which group in the ParameterArchive were changed. 
	/// </summary>
	public struct ParameterEvent {
		#region OBJECT_ATTRIBUTES
		//==========================================================================
		public readonly ParameterArchive archive;
		public readonly string group;
		private readonly List<string> KEYS;
		//==========================================================================
		#endregion

		#region CONSTRUCTOR
		//==========================================================================
		public ParameterEvent(ParameterArchive archive, string group, List<string> keys){
			this.archive	= archive;
			this.group		= group;
			this.KEYS		= keys;
		}
		//==========================================================================
		#endregion

		#region OBJECT_FUNCTIONS
		//==========================================================================
		public bool ContainsKey(string item) {
			return KEYS.Contains(item);
		}
		//==========================================================================
		#endregion

		#region GETTER_AND_SETTER
		//==========================================================================
		public string this[int index]{
			get{
				return KEYS[index];
			}
		}

		public int Count{
			get{
				return KEYS.Count;
			}
		}
		//==========================================================================
		#endregion
	}
}
